// CompareSinDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CompareSin.h"
#include "CompareSinDlg.h"
#include "WinGraf.h"
#include <math.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCompareSinDlg dialog

CCompareSinDlg::CCompareSinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCompareSinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCompareSinDlg)
	m_kff = 0.0;
	m_phaza = 0;
	m_result = _T("");
	m_n = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCompareSinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompareSinDlg)
	DDX_Text(pDX, IDC_Ekff, m_kff);
	DDX_Text(pDX, IDC_Ephaza, m_phaza);
	DDX_Text(pDX, IDC_Eresult, m_result);
	DDX_Text(pDX, IDC_EnPeriod, m_n);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCompareSinDlg, CDialog)
	//{{AFX_MSG_MAP(CCompareSinDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Bfill, OnBfill)
	ON_BN_CLICKED(IDC_Bcompare, OnBcompare)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompareSinDlg message handlers

BOOL CCompareSinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCompareSinDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCompareSinDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCompareSinDlg::OnBfill() 
{
int i;
double x,dx,phaza,sinx;
double pi = 3.1415926535;

  UpdateData(true);

  if(m_n==0)m_n=1;
  dx=2*pi/1024.0*m_n;

  if(m_kff==0.0)m_kff=1.0;
  if(m_phaza==0)phaza=0;
  else phaza=pi*m_phaza/180.0;//  


  for(i=0,x=pi/2;i<1024;i++,x+=dx)
  {
    sinx=sin(x);
    bufINPUT[i]=(int)(sin(x)*32767);
	sinx=sin(x+phaza);
	bufOUTPUT[i]=(int)(m_kff*sin(x+phaza)*32767);
  }
}

void CCompareSinDlg::OnBcompare() 
{
	int maxI,maxO,i,kz;
	WinGraf WGraf;

	for(i=0;i<1024;i++)
	{
	  WGraf.bufI[i]=bufINPUT[i];
      WGraf.bufO[i]=bufOUTPUT[i];
	}
		WGraf.DoModal();
	maxI=maxSIN(bufINPUT);
	maxO=maxSIN(bufOUTPUT);
	
	kz=compBuf(bufINPUT, bufOUTPUT, 0, 0);
m_result.Format(":\r\n =%d  =%d\r\n    %d ",maxI,maxO,kz);
	UpdateData(false);

}

int CCompareSinDlg::maxSIN(int *buf)
{
  int maxx,i;

  for(i=0,maxx=0;i<1024;i++)
	  if(*(buf+i)>maxx)maxx=*(buf+i);
  return maxx;
}

int CCompareSinDlg::compBuf(int *buf1, int *buf2, int i1, int i2)
{
int i,j1,j2,n,kz;
kz=0;
n=1024-((i1>i2)?i1:i2);
for(i=0,j1=i1,j2=i2;i<n;i++,j1++,j2++)
   if ((fabs(double( *(buf1+j1)- *(buf2+j2))/ (*(buf1+j1))*100.0))>10.0)
	   kz++;

return kz;
}
